Uses Crt,Svga,SImage1,SImage2,CpuType,OSDetect,Dos;

Const MIDIHeader : Array[1..3] of Char= ('M','I','D');

Type MenuArray = Array[1..6] of String;

Const _PortArray : MenuArray = ('210h','220h','230h','240h','250h','260h');
      _IrqArray : MenuArray = ('2','3','5','7','10','');
      _DmaArray : MenuArray = ('0','1','2','3','','');

Var
Ch : Char;
Port : Word;
DIrq,DDma : Byte;
S : Array[1..3] of Char;
I,I2,I3 : String;
F : File;
P1,P2 : Pointer;
CurM : LongInt;
M : Array[1..7] of String;
A,B,C : LongInt;
SClean,Clean : Pointer;
MOn,DOn : Boolean;
ErCd : Integer;

Function Hex16 ( i : longint) : char;
Begin
  case i of
  0..9 : Hex16:=chr(i+48);
  10 : hex16:='A';
  11 : hex16:='B';
  12 : hex16:='C';
  13 : hex16:='D';
  14 : hex16:='E';
  15 : hex16:='F';
  end;
End;

Function Hex256 (i : longint) : String;
Begin
  Hex256:=Hex16(i div 16)+Hex16(i mod 16);
End;

Function Hex(i : Longint) : string;
Var S : String;
Begin
  If I=0 then Begin Hex:='0'; Exit; End;
  S:=Hex256(i div 256)+Hex256(i mod 256);
  While S[1]='0' do Delete(S,1,1);
  Hex:=S;
End;

Function GetValue(S : MenuArray;N,Cur : Byte) : Byte;
Var A : Byte;
Ch : Char;
CurM : Byte;
Begin
  CurM:=Cur;
  Repeat
    For A:=1 to N do
    Begin
      If CurM=A then
        Print(S[A],420,330+A*14,190) else
        Print(S[A],420,330+A*14,90);
    End;
    Ch:=ReadKey;
    If Ch=#0 then
    Begin
      Ch:=ReadKey;
      If Ch='H' then Dec(CurM);
      If Ch='P' then Inc(CurM);
      If CurM<1 then CurM:=N;
      If CurM>N then CurM:=1;
    End;
  Until (Ch=#13) or (Ch=#27);
  If Ch=#13 then
    GetValue:=CurM else
    GetValue:=Cur;
  ShowImage(Clean,420,344,4*16,6*16);
End;

Begin
  GetMem(SClean,256);
  GetMem(Clean,4*6*256);
  FillChar(Clean^,4*6*256,0);
  FillChar(SClean^,256,0);
  InitSvga;
  Cls(0);
  SetPalette(TPalette(@ImgPal2^));
  SetVesaBank(1);
  P1:=@Img1;
  P2:=@Img2;
  asm
    push ds
    mov ax,$A000
    mov es,ax
    mov di,384+640
    lds si,P1
    mov cx,64511
    rep movsb
    pop ds
  end;
  SetVesaBank(2);
  asm
    push ds
    mov ax,$A000
    mov es,ax
    xor di,di
    lds si,P2
    mov cx,63489
    rep movsb
    pop ds
  end;
  Print('                ॡ:         ⥬:',10,0,90);
  I2:=CPU_TypeStr;
  Str(IntCPUSpeed,I);
  Print(':     386           '+I2+' '+I+'Mhz',0,14,90);
  Print('-:   易⥫                  '+CoPro_TypeStr,0,28,90);
  InitMulti;
  Str(lo(DosVersion),I);
  Str(hi(DosVersion),I2);
  I:=I+'.'+I2;
  I2:='';
  Case Task.OS of
  0: I2:='';
  1: I2:=' (Windows';
  2: I2:=' (OS/2';
  3: I2:=' (DESQview';
  4: I2:=' (TopView';
  End;
  If I2<>'' then
  Begin
    Str(hi(Task.Version),I3);
    I2:=I2+' ver '+I3+'.';
    Str(lo(Task.Version),I3);
    I2:=I2+I3+')';
  End;
  Print(' DOS:    MS-DOS 5.0                '+'MS-DOS '+I+I2,0,42,90);
  Print(':          VESA-ᮢ⨬  ॡ 㤢⢮',0,56,90);
  Print('Sound Blaster configuration :',200,320,90);
  Assign(F,'labirint.exe');
  ReSet(F,1);
  Seek(F,FileSize(F)-9);
  BlockRead(F,S,3);
  If S=MIDIHEADER then
  Begin
    BlockRead(F,Port,2);
    BlockRead(F,MOn,1);
    BlockRead(F,DOn,1);
    BlockRead(F,DIrq,1);
    BlockRead(F,DDma,1);
  End else
  Begin
    Port:=$220;
    MOn:=True;
    DOn:=True;
    DIrq:=5;
    DDma:=1;
  End;
  Close(F);
  CurM:=1;
  M[6]:='Save and exit';
  M[7]:='Exit without saving';
  Repeat
    If Not MOn then I:='Off' else I:='On';
    ShowImage(SClean,284,344,16,16);
    ShowImage(SClean,292,344,16,16);
    M[1]:='Music: '+I;
    If Not DOn then I:='Off' else I:='On';
    ShowImage(SClean,284,358,16,16);
    ShowImage(SClean,292,358,16,16);
    M[2]:='Sound: '+I;
    ShowImage(SClean,308,372,16,16);
    M[3]:='Base Port: '+Hex(Port)+'h';
    ShowImage(SClean,252,386,16,16);
    M[4]:='Irq: '+Hex(DIrq);
    ShowImage(SClean,252,400,16,16);
    M[5]:='Dma: '+Hex(DDma);
    For A:=1 to 7 do
    Begin
      If CurM=A then
        Print(M[A],220,330+A*14,190) else
        Print(M[A],220,330+A*14,90);
    End;
    Ch:=ReadKey;
    If Ch=#0 then
    Begin
      Ch:=ReadKey;
      If Ch='H' then Dec(CurM);
      If Ch='P' then Inc(CurM);
      If CurM<1 then CurM:=7;
      If CurM>7 then CurM:=1;
    End else
      If Ch=#13 then
      Case CurM of
      1: MOn:=Not MOn;
      2: DOn:=Not DOn;
      3: Case GetValue(_PortArray,6,(Port-$200) shr 4) of
           1:Port:=$210;
           2:Port:=$220;
           3:Port:=$230;
           4:Port:=$240;
           5:Port:=$250;
           6:Port:=$260;
          End;
      4:
      Begin
        Case DIrq of
        2:A:=1;
        3:A:=2;
        5:A:=3;
        7:A:=4;
        10:A:=5;
        End;
        Val(_IrqArray[GetValue(_IrqArray,5,A)],DIrq,ErCd);
      End;
      5: DDma:=GetValue(_DmaArray,4,DDma+1)-1;
      End;
  Until ((CurM>5) and (Ch=#13)) or (Ch=#27);
  If (CurM=6) and (Ch=#13) then
  Begin
    ReSet(F,1);
    Seek(F,FileSize(F)-9);
    BlockRead(F,S,3);
    If S<>MIDIHEADER then
    Begin
      Seek(F,FileSize(F));
      BlockWrite(F,MIDIHEADER,3);
    End;
    BlockWrite(F,Port,2);
    BlockWrite(F,MOn,1);
    BlockWrite(F,DOn,1);
    BlockWrite(F,DIrq,1);
    BlockWrite(F,DDma,1);
    Close(F);
  End;
  DoneSvga;
  FreeMem(SClean,256);
  FreeMem(Clean,4*6*256);
End.